;-------------------------------------------------------------------------------
; hots   gui
;
;   Copyright (C) 2008, 2009 Alesc
;   This program is free software: you can redistribute it and/or modify
;   it under the terms of the GNU General Public License.
;-------------------------------------------------------------------------------

;-------------------------------------------------------------------------------
; options gui
;-------------------------------------------------------------------------------
CreateOptionsGUI()
{
    global
    ; suspend hotkeys
    Hotkeys("Off")

    Gui, %options_GUIhandle%:Add, Tab2, x0 y0 h380 w480, Program|Ctags
    ; 1st tab...program options
        ; pspad hotkey
    Gui, %options_GUIhandle%:Tab, Program
    Gui, %options_GUIhandle%:Add, Text, x40 y40 w80 h20 , PSPad hotkey:
    Gui, %options_GUIhandle%:Add, Hotkey, x120 y40 w120 h20 +Left vpsp_action_key_gui, 
    psp_action_key_gui_TT := "PSPad hotkey calls jscript which controls pspad."
        ; buffer size
    Gui, %options_GUIhandle%:Add, Text, x40 y80 w80 h20 , Undo buffer size:
    Gui, %options_GUIhandle%:Add, Edit, x120 y80 w80 h20 vhot_history_size_gui Limit,
    hot_history_size_gui_TT := "How big will the history be."
    Gui, %options_GUIhandle%:Add, UpDown, x200 y80 w20 h20 , UpDown
        ; ctag control
    Gui, %options_GUIhandle%:Add, GroupBox, x10 y110 w390 h60 ,
    Gui, %options_GUIhandle%:Add, Text, x20 y125 w80 h20 , Undo:
    Gui, %options_GUIhandle%:Add, Hotkey, x20 y140 w110 h20 +Left vhot_undo_key_gui, 
    hot_undo_key_gui_TT := "Undo."
    Gui, %options_GUIhandle%:Add, Text, x150 y125 w80 h20 , Goto:
    Gui, %options_GUIhandle%:Add, Hotkey, x150 y140 w110 h20 +Left vhot_goto_key_gui, 
    hot_goto_key_gui_TT := "Goto tag."
    Gui, %options_GUIhandle%:Add, Text, x280 y125 w80 h20 , Redo:
    Gui, %options_GUIhandle%:Add, Hotkey, x280 y140 w110 h20 +Left vhot_redo_key_gui, 
    hot_redo_key_gui_TT := "Redo."

    Gui, %options_GUIhandle%:Add, Text, x40 y180 w80 h20 , Autocomplete:
    Gui, %options_GUIhandle%:Add, DropDownList, x120 y180 w120 R5 vhot_autocomplete_key_gui, Ctrl|Shift|Alt|Tab|Space
    hot_autocomplete_key_gui_TT := "Select double keypress"

    Gui, %options_GUIhandle%:Add, CheckBox, x40 y250 w150 h20 vhot_debugs_gui, Debugs
    hot_debugs_gui_TT := "Enagle debuging for Hots."

    ; 2nd tab...ctags options
    Gui, %options_GUIhandle%:Tab, Ctags
    Gui, %options_GUIhandle%:Add, Text, x40 y40 w80 h20 , Ctags files:
    Gui, %options_GUIhandle%:Add, Edit, x100 y40 w210 h20 vhot_ctags_file_gui,
    hot_ctags_file_gui_TT := "Select ctags files to use."
    Gui, %options_GUIhandle%:Add, Button, x310 y40 w20 h20 gBrowseCtagsFile, ...
    Gui, %options_GUIhandle%:Add, CheckBox, x40 y80 w150 h20 vhot_case_sensitive_gui Checked, Case sensitive tags match
    ; TODO maybe a usefull option
    ;Gui, %options_GUIhandle%:Add, CheckBox, x40 y120 w150 h20 vhot_search_all_gui, Search all ctags
    ;hot_search_all_gui_TT := "Will search for tag in all ctags files."

    ; common controls
    Gui, %options_GUIhandle%:Tab
    Gui, %options_GUIhandle%:Add, Button, x126 y344 w100 h30 -Wrap gOptionsSave, Save
    Gui, %options_GUIhandle%:Add, Button, x246 y344 w100 h30 -Wrap gOptionsCancel, Cancel
    Gui, %options_GUIhandle%:Add, Button, x366 y344 w100 h30 -Wrap gOptionsHelp, Help

    ; update gui with saved options
    GuiControl, %options_GUIhandle%:, psp_action_key_gui, %PSP_ACTION_KEY%
    GuiControl, %options_GUIhandle%:, hot_ctags_file_gui, %HOT_CTAGS_FILES%
    GuiControl, %options_GUIhandle%:, hot_case_sensitive_gui, %HOT_CASE_SENSITIVE%
    GuiControl, %options_GUIhandle%:, hot_history_size_gui, %HOT_HISTORY_SIZE%
    GuiControl, %options_GUIhandle%:, hot_undo_key_gui, %HOT_UNDO_KEY%
    GuiControl, %options_GUIhandle%:, hot_goto_key_gui, %HOT_GOTO_KEY%
    GuiControl, %options_GUIhandle%:, hot_redo_key_gui, %HOT_REDO_KEY%
    GuiControl, %options_GUIhandle%:ChooseString, hot_autocomplete_key_gui, %HOT_AUTOCOMPLETE_KEY%
    GuiControl, %options_GUIhandle%:, hot_search_all_gui, %HOT_SEARCH_ALL%
    ReadDebugEnv(title)
    GuiControl, %options_GUIhandle%:, hot_debugs_gui, %DEBUG%

    OnMessage(0x200, "WM_MOUSEMOVE")
    Gui, %options_GUIhandle%:Show, Center h380 w480, Hots options
}

OptionsSave:
    Gui, %options_GUIhandle%:Submit, NoHide

    PSP_ACTION_KEY := psp_action_key_gui
    HOT_HISTORY_SIZE := hot_history_size_gui
    HOT_UNDO_KEY := hot_undo_key_gui
    HOT_GOTO_KEY := hot_goto_key_gui
    HOT_REDO_KEY := hot_redo_key_gui
    HOT_AUTOCOMPLETE_KEY := hot_autocomplete_key_gui
    HOT_CTAGS_FILES := hot_ctags_file_gui
    HOT_CASE_SENSITIVE := hot_case_sensitive_gui
    HOT_SEARCH_ALL := hot_search_all_gui
    WriteDebugEnv(title, hot_debugs_gui)

    HOT_CASE_SENSITIVE_STR := GetCaseSens(HOT_CASE_SENSITIVE)
    InitPSPlib(PSP_ACTION_KEY, "hots", HOT_TMP_PATH)

    UpdateCtagMenu()

    WriteHotIni()

    HINT = 
    (
    %HOT_GOTO_KEY%   jump into function
    %HOT_UNDO_KEY%   undo
    %HOT_REDO_KEY%   redo
    %HOT_AUTOCOMPLETE_KEY%   code autocomplete
    )

    Gui, %options_GUIhandle%:Destroy
    Hotkeys("On")
return

OptionsCancel:
    Hotkeys("On")
    Gui, %options_GUIhandle%:Destroy
return

;---------------------------------------
; CheckOptions
;
; Arguments: None
;
; Returns:
;   HOT_ERR / HOT_OK
;
; Description
;   Checks if options are set 
;   at least a little bit correctly
;---------------------------------------
CheckOptions()
{
    global
    local opt_errors = 0

    if (PSP_ACTION_KEY = "")
    {
        opt_errors += 1
    }
    IfNotExist, %HOT_CTAGS_FILE%
    {
        Report("", "Please set proper ctag file.")
        opt_errors += 1
    }
    if HOT_HISTORY_SIZE =
        opt_errors += 1
    if HOT_HISTORY_SIZE < 1
        opt_errors += 1

    if opt_errors > 0
        return %HOT_ERR%

    return %HOT_OK%
}

OptionsHelp:
    HelpStart()
return

BrowseCtagsFile:
    Gui, %options_GUIhandle%:+OwnDialogs
    previousFiles = 
    GuiControlGet, hot_ctags_file_gui, %options_GUIhandle%:
    previousFiles = %hot_ctags_file_gui%

    FileSelectFile, selectedFiles, M,
    Loop, parse, selectedFiles, `n
    {
        if A_Index = 1
        {
            filesPath := RegExReplace(A_LoopField, "\\$", "")
            file = %previousFiles%
        }

        if A_Index > 1
        {
            file = %file%%filesPath%\%A_LoopField%;
            GuiControl, %options_GUIhandle%:, hot_ctags_file_gui, %file%
            
        }
    }
return

WM_MOUSEMOVE()
{
    ; _TT is kept blank for use by the ToolTip command below.
    static CurrControl, PrevControl, _TT
    CurrControl := A_GuiControl

    If (CurrControl <> PrevControl and not InStr(CurrControl, " "))
    {
        ; Turn off any previous tooltip.
        ToolTip
        SetTimer, DisplayToolTip, 1000
        PrevControl := CurrControl
    }
    return

    DisplayToolTip:
    SetTimer, DisplayToolTip, Off
    IfInString, CurrControl, ...
        return
    ; The leading percent sign tell it to use an expression.
    ToolTip % %CurrControl%_TT
    SetTimer, RemoveToolTip, 3000
    return

    RemoveToolTip:
    SetTimer, RemoveToolTip, Off
    ToolTip
    return
}

;-------------------------------------------------------------------------------
; multitags gui
;-------------------------------------------------------------------------------
CreateMultitagsGUI()
{
    local maxlen, tmplen, mt_height, mt_width
    local mt_maxHeight, mt_maxWidth, filename, line

    Gui, %multitag_GUIhandle%:Font, s%fontSize%, %fontType%
    Gui, %multitag_GUIhandle%:Add, Button, Hidden Default gMultitagsOk,
    Gui, %multitag_GUIhandle%:+Resize

    ; find the longest line
    maxlen = 0
    Loop %tag_index%
    {
        tmplen := StrLen(tags_file%A_Index%) + StrLen(tags_line%A_Index%) + StrLen(tags_desc%A_Index%)
        if (maxlen < tmplen)
            maxlen := tmplen
    }

    ; ugly and not water proof
    mt_height := tag_index * 25 + 10
    mt_width := maxlen * 10

    ; get screen size and mouse position
    MouseGetPos, mt_posx, mt_posy
    SysGet, workArea, MonitorWorkArea, 0
    mt_maxHeight := Abs((workAreaBottom * 0.90) - mt_posy)
    mt_maxWidth := A_ScreenWidth * 0.50

    ; do not allowe gui to go over screen 
    if (mt_height > mt_maxHeight)
        mt_height := mt_maxHeight
    if (mt_width > mt_maxWidth)
        mt_width := mt_maxWidth

    Gui, %multitag_GUIhandle%:Add, ListView, x0 y0 w%mt_width% h%mt_height% vmultitagsView gMultitagsView Background%backColor% -Multi, File name|Line number|Details
    ; insert data into list view
    Loop %tag_index%
        LV_Add("cWhite", tags_file%A_Index%, tags_line%A_Index%, tags_desc%A_Index%)

    LV_ModifyCol(1, "AutoHdr")
    LV_ModifyCol(2, "AutoHdr")
    LV_ModifyCol(3, "AutoHdr")
    Gui, %multitag_GUIhandle%:Show, x%mt_posx% y%mt_posy% w%mt_width% h%mt_height%, Multitags %title%
}

MultitagsView:
if A_GuiEvent = DoubleClick
{
    ; get the text from the row's first and second field.
    LV_GetText(filename, A_EventInfo)
    LV_GetText(line, A_EventInfo, 2)

    Gui, %multitag_GUIhandle%:Destroy
    if GetPSPCaretPos(prev_filename, ycaret, xcaret) = HOT_ERR
        return

    start_line = %prev_filename% %ycaret%
    WriteHistLine(start_line, HOT_HISTORY_SIZE, HOT_HISTORY_FILE)
    new_line = %filename% %line%
    WriteHistLine(new_line, HOT_HISTORY_SIZE, HOT_HISTORY_FILE)
    ExecPSPFunc("hots_ctag.moveto("AhkToPSPPath(HOT_HISTORY_FILE) . ")")
}
return


MultitagsOk:
    GuiControlGet, FocusedControl, FocusV
    if FocusedControl <> multitagsView
        return
    ; get the text from the row's first field.
    LV_GetText(filename, LV_GetNext(0, "Focused"))
    LV_GetText(line, LV_GetNext(0, "Focused"), 2)

    Gui, %multitag_GUIhandle%:Destroy
    if GetPSPCaretPos(prev_filename, ycaret, xcaret) = HOT_ERR
        return

    start_line = %prev_filename% %ycaret%
    WriteHistLine(start_line, HOT_HISTORY_SIZE, HOT_HISTORY_FILE)
    new_line = %filename% %line%
    WriteHistLine(new_line, HOT_HISTORY_SIZE, HOT_HISTORY_FILE)
    ExecPSPFunc("hots_ctag.moveto("AhkToPSPPath(HOT_HISTORY_FILE) . ")")
return

GuiSize:
    ; The window has been minimized. No action needed.
    if A_EventInfo = 1
        return
    ; Otherwise, the window has been resized or maximized. Resize the Multitags to match.
    GuiControl, %multitag_GUIhandle%:Move, multitagsView, % "W" . A_GuiWidth . " H" . A_GuiHeight
return
;-------------------------------------------------------------------------------
; autocomplete gui
;-------------------------------------------------------------------------------
CreateCompleteGUI()
{
    global
    local maxlen = 0, tmplen = 0, width
    local position, sel_tag, line

    Gui, %completetag_GUIhandle%:+ToolWindow
    Gui, %completetag_GUIhandle%:Font, s%fontSize%, %fontType%
    Gui, %completetag_GUIhandle%:Add, Button, Hidden Default gCompleteOk,
    Gui, %completetag_GUIhandle%:Add, ListView, x20 y0 w290 h150 vcompleteView gCompleteView Background%backColor% -Multi, %title%
    GUI, %completetag_GUIhandle%:Add, Button, +0x8000 gCompleteViewClose x2 y2 w15 h15, x
    Gui, %completetag_GUIhandle%:+AlwaysOnTop -Caption +Border

    ; TODO width not used??
    Loop %tag_index%
    {
        tmplen := StrLen(tags%A_Index%)
        if (maxlen < tmplen)
            maxlen := tmplen
        LV_Add("cWhite", tags%A_Index%)
    }
    width := maxlen * 10
    Gui, %completetag_GUIhandle%:Show, x%A_CaretX% y%A_CaretY% w310 h150, Mutliball %title%
}

CompleteView:
if A_GuiEvent = DoubleClick
{
    ; get the text
    LV_GetText(sel_tag, A_EventInfo)
    Gui, %completetag_GUIhandle%:Destroy

    position := RegExMatch(sel_tag,  caseSens . ")(" . word . "(\w*))", line)

    if (position != 0 and line2 != "")
    {
        SendToPSP(line2, 0, 1)
    }
    else if (position = 0)
        Report("Error", "Line match error.")
}
return

CompleteOk:
    GuiControlGet, FocusedControl, FocusV
    if FocusedControl <> completeView
        return
    ; get the text
    LV_GetText(sel_tag, LV_GetNext(0, "Focused"))
    Gui, %completetag_GUIhandle%:Destroy

    position := RegExMatch(sel_tag,  caseSens . ")(" . word . "(\w*))", line)

    if (position != 0 and line2 != "")
    {
        SendToPSP(line2, 0, 1)
    }
    else if (position = 0)
        Report("Error", "Line match error.")
return

CompleteViewClose:
    Gui, %completetag_GUIhandle%:Destroy
return
;-------------------------------------------------------------------------------
; about gui
;-------------------------------------------------------------------------------
AboutHots()
{
    global

    Gui, %about_GUIhandle%:Color, Green
    Gui, %about_GUIhandle%:Add, Picture, x6 y4 w200 h170 , .\resources\hots_about.jpg
    Gui, %about_GUIhandle%:Add, Button, x156 y294 w85 h25 -Wrap gCheckUpdates vBlaXYxx, Check Updates
    Gui, %about_GUIhandle%:Add, Button, x256 y294 w85 h25 -Wrap gAboutOk, OK
    Gui, %about_GUIhandle%:Font, s20
    Gui, %about_GUIhandle%:Add, Text, x206 y4 w150 h50 cWhite +Center, %title%
    Gui, %about_GUIhandle%:Font, s10
    Gui, %about_GUIhandle%:Add, Text, x210 y90 w180 h20 cWhite +Left, Program version: 
    Gui, %about_GUIhandle%:Font, Bold
    Gui, %about_GUIhandle%:Add, Text, x316 y90 w30 h20 cWhite +Center, %version%
    Gui, %about_GUIhandle%:Font, s10 Norm
    Gui, %about_GUIhandle%:Add, Text, x210 y110 w150 h80 cWhite +Left, Author: 
    Gui, %about_GUIhandle%:Font, Bold
    Gui, %about_GUIhandle%:Add, Text, x315 y110 w50 h80 cWhite +Center, Alesc
    Gui, %about_GUIhandle%:Font, s10 Norm
    Gui, %about_GUIhandle%:Add, Text, x6 y194 cWhite, Home web page:
    Gui, %about_GUIhandle%:Font, s10 Norm underline
    ProjWWW = %TITLE%
    Gui, %about_GUIhandle%:Add, Text, x120 y194 cWhite gLaunchProjWWW vWWW, http://%ProjWWW%.sourceforge.net/
    WWW_TT := "Click"
    Gui, %about_GUIhandle%:Show, Center h343 w369, About Hots
    return
}

AboutOk:
    Gui, %about_GUIhandle%:Destroy
return

CheckUpdates:
    GetUpdate(TITLE, VERSION, HOT_TMP_PATH)
return
;-------------------------------------------------------------------------------
; common functions for gui
;-------------------------------------------------------------------------------
GuiEscape:
    Gui, %multitag_GUIhandle%:Destroy
    Gui, %options_GUIhandle%:Destroy
    Gui, %about_GUIhandle%:Destroy
return

GuiClose:
    Gui, %multitag_GUIhandle%:Destroy
    Gui, %options_GUIhandle%:Destroy
    Gui, %about_GUIhandle%:Destroy
return

